/* sqlheavy-queryable.c generated by valac 0.28.1, the Vala compiler
 * generated from sqlheavy-queryable.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include "SQLHeavy.h"
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdio.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_mapped_file_unref0(var) ((var == NULL) ? NULL : (var = (g_mapped_file_unref (var), NULL)))



static SQLHeavyTransaction* sql_heavy_queryable_real_begin_transaction (SQLHeavyQueryable* self, GError** error);
static GHashTable* sql_heavy_queryable_va_list_to_hash_table (va_list args, GError** error);
static void _g_free0_ (gpointer var);
static void _vala_GValue_free (GValue* self);
static void __vala_GValue_free0_ (gpointer var);
static GValue* _g_value_dup (GValue* self);
void sql_heavy_query_set_list (SQLHeavyQuery* self, gboolean has_first_parameter, const gchar* first_parameter, va_list args, GError** error);
static void sql_heavy_queryable_run_internal (SQLHeavyQueryable* self, const gchar* sql, gssize max_len, GError** error);
static SQLHeavyQuery* sql_heavy_queryable_real_prepare (SQLHeavyQueryable* self, const gchar* sql, GError** error);
static void sql_heavy_queryable_real_run_file (SQLHeavyQueryable* self, GFile* file, GError** error);
static void sql_heavy_queryable_real_print_table (SQLHeavyQueryable* self, const gchar* sql, FILE* fd, GError** error);


/**
     * Lock the queryable and refuse to run any queries against it.
     *
     * @see unlock
     */
void sql_heavy_queryable_lock (SQLHeavyQueryable* self) {
	g_return_if_fail (self != NULL);
	SQL_HEAVY_QUERYABLE_GET_INTERFACE (self)->lock (self);
}


/**
     * Unlock the queryable and allow queries to be run against it.
     *
     * @see lock
     */
void sql_heavy_queryable_unlock (SQLHeavyQueryable* self) {
	g_return_if_fail (self != NULL);
	SQL_HEAVY_QUERYABLE_GET_INTERFACE (self)->unlock (self);
}


/**
     * Queue a query to be executed when the queryable is unlocked
     *
     * @param query the query to queue
     */
void sql_heavy_queryable_queue (SQLHeavyQueryable* self, SQLHeavyQuery* query, GError** error) {
	g_return_if_fail (self != NULL);
	SQL_HEAVY_QUERYABLE_GET_INTERFACE (self)->queue (self, query, error);
}


/**
     * Begin a transaction. Will lock the queryable until the transaction is resolved.
     *
     * @return a new transaction
     */
static SQLHeavyTransaction* sql_heavy_queryable_real_begin_transaction (SQLHeavyQueryable* self, GError** error) {
	SQLHeavyTransaction* result = NULL;
	SQLHeavyTransaction* _tmp0_ = NULL;
	SQLHeavyTransaction* _tmp1_ = NULL;
	SQLHeavyTransaction* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	_tmp1_ = sql_heavy_transaction_new (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == SQL_HEAVY_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp2_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp2_;
	_g_object_unref0 (_tmp0_);
	return result;
}


SQLHeavyTransaction* sql_heavy_queryable_begin_transaction (SQLHeavyQueryable* self, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return SQL_HEAVY_QUERYABLE_GET_INTERFACE (self)->begin_transaction (self, error);
}


/**
     * Parse variadic arguments into a hash table
     *
     * @param args the list of arguments to parse
     */
static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _vala_GValue_free (GValue* self) {
	g_value_unset (self);
	g_free (self);
}


static void __vala_GValue_free0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer __g_value_dup0 (gpointer self) {
	return self ? _g_value_dup (self) : NULL;
}


static GHashTable* sql_heavy_queryable_va_list_to_hash_table (va_list args, GError** error) {
	GHashTable* result = NULL;
	GHashTable* parameters = NULL;
	GHashFunc _tmp0_ = NULL;
	GEqualFunc _tmp1_ = NULL;
	GHashTable* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, __vala_GValue_free0_);
	parameters = _tmp2_;
	{
		const gchar* current_parameter = NULL;
		const gchar* _tmp3_ = NULL;
		_tmp3_ = va_arg (args, gchar*);
		current_parameter = _tmp3_;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				const gchar* _tmp6_ = NULL;
				GType gtype = 0UL;
				GType _tmp7_ = 0UL;
				GValue gval = {0};
				GType _tmp8_ = 0UL;
				GValue _tmp9_ = {0};
				gboolean _tmp10_ = FALSE;
				GType _tmp11_ = 0UL;
				GHashTable* _tmp24_ = NULL;
				const gchar* _tmp25_ = NULL;
				gchar* _tmp26_ = NULL;
				GValue _tmp27_ = {0};
				GValue _tmp28_ = {0};
				GValue* _tmp29_ = NULL;
				if (!_tmp4_) {
					const gchar* _tmp5_ = NULL;
					_tmp5_ = va_arg (args, gchar*);
					current_parameter = _tmp5_;
				}
				_tmp4_ = FALSE;
				_tmp6_ = current_parameter;
				if (!(_tmp6_ != NULL)) {
					break;
				}
				_tmp7_ = va_arg (args, GType);
				gtype = _tmp7_;
				_tmp8_ = gtype;
				g_value_init (&_tmp9_, _tmp8_);
				gval = _tmp9_;
				_tmp11_ = gtype;
				if (_tmp11_ == G_TYPE_INT64) {
					_tmp10_ = TRUE;
				} else {
					GType _tmp12_ = 0UL;
					_tmp12_ = gtype;
					_tmp10_ = _tmp12_ == G_TYPE_INT;
				}
				if (_tmp10_) {
					gint64 _tmp13_ = 0LL;
					_tmp13_ = va_arg (args, gint64);
					g_value_set_int64 (&gval, _tmp13_);
				} else {
					GType _tmp14_ = 0UL;
					_tmp14_ = gtype;
					if (_tmp14_ == G_TYPE_DOUBLE) {
						gdouble _tmp15_ = 0.0;
						_tmp15_ = va_arg (args, gdouble);
						g_value_set_double (&gval, _tmp15_);
					} else {
						GType _tmp16_ = 0UL;
						_tmp16_ = gtype;
						if (_tmp16_ == G_TYPE_STRING) {
							const gchar* _tmp17_ = NULL;
							_tmp17_ = va_arg (args, gchar*);
							g_value_set_string (&gval, _tmp17_);
						} else {
							GType _tmp18_ = 0UL;
							_tmp18_ = gtype;
							if (_tmp18_ == G_TYPE_BYTE_ARRAY) {
								void* _tmp19_ = NULL;
								_tmp19_ = va_arg (args, void*);
								g_value_set_boxed (&gval, _tmp19_);
							} else {
								GType _tmp20_ = 0UL;
								_tmp20_ = gtype;
								if (_tmp20_ == G_TYPE_POINTER) {
									g_value_set_pointer (&gval, NULL);
								} else {
									GType _tmp21_ = 0UL;
									const gchar* _tmp22_ = NULL;
									GError* _tmp23_ = NULL;
									_tmp21_ = gtype;
									_tmp22_ = g_type_name (_tmp21_);
									_tmp23_ = g_error_new (SQL_HEAVY_ERROR, SQL_HEAVY_ERROR_DATA_TYPE, "Data type (`%s') unsupported.", _tmp22_);
									_inner_error_ = _tmp23_;
									if (_inner_error_->domain == SQL_HEAVY_ERROR) {
										g_propagate_error (error, _inner_error_);
										G_IS_VALUE (&gval) ? (g_value_unset (&gval), NULL) : NULL;
										_g_hash_table_unref0 (parameters);
										return NULL;
									} else {
										G_IS_VALUE (&gval) ? (g_value_unset (&gval), NULL) : NULL;
										_g_hash_table_unref0 (parameters);
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
										g_clear_error (&_inner_error_);
										return NULL;
									}
								}
							}
						}
					}
				}
				_tmp24_ = parameters;
				_tmp25_ = current_parameter;
				_tmp26_ = g_strdup (_tmp25_);
				_tmp27_ = gval;
				_tmp28_ = _tmp27_;
				_tmp29_ = __g_value_dup0 (&_tmp28_);
				g_hash_table_replace (_tmp24_, _tmp26_, _tmp29_);
				G_IS_VALUE (&gval) ? (g_value_unset (&gval), NULL) : NULL;
			}
		}
	}
	result = parameters;
	return result;
}


/**
     * Execute the supplied SQL
     *
     * This function accepts an arbitrary number of groups of
     * arguments for binding values. The first argument in the group
     * must be the name of the parameter to bind, the second a GType,
     * and the third the value.
     *
     * @param sql the SQL to execute
     * @return the result
     * @see Query.execute
     */
static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


SQLHeavyQueryResult* sql_heavy_queryable_execute (SQLHeavyQueryable* self, const gchar* sql, GError** error, ...) {
	SQLHeavyQueryResult* result = NULL;
	const gchar* s = NULL;
	const gchar* _tmp0_ = NULL;
	va_list args = {0};
	SQLHeavyQueryResult* _result_ = NULL;
	GHashTable* parameters = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (sql != NULL, NULL);
	_tmp0_ = sql;
	s = _tmp0_;
	va_start (args, error);
	_result_ = NULL;
	parameters = NULL;
	{
		gchar* sp = NULL;
		const gchar* _tmp1_ = NULL;
		_tmp1_ = s;
		sp = (gchar*) _tmp1_;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gchar* _tmp5_ = NULL;
				gchar* _tmp6_ = NULL;
				gboolean _tmp7_ = FALSE;
				if (!_tmp2_) {
					gchar* _tmp3_ = NULL;
					gchar* _tmp4_ = NULL;
					_tmp3_ = sp;
					sp = _tmp3_ + 1;
					_tmp4_ = sp;
					s = (const gchar*) _tmp4_;
				}
				_tmp2_ = FALSE;
				_tmp5_ = sp;
				if (!((*_tmp5_) != '\0')) {
					break;
				}
				_tmp6_ = sp;
				_tmp7_ = g_ascii_isspace (*_tmp6_);
				if (!_tmp7_) {
					SQLHeavyQuery* query = NULL;
					gint param_count = 0;
					SQLHeavyQuery* _tmp17_ = NULL;
					gint _tmp18_ = 0;
					gint _tmp19_ = 0;
					SQLHeavyQueryResult* _tmp40_ = NULL;
					SQLHeavyQuery* _tmp41_ = NULL;
					SQLHeavyQueryResult* _tmp42_ = NULL;
					SQLHeavyQueryResult* _tmp43_ = NULL;
					query = NULL;
					{
						SQLHeavyQueryResult* _tmp8_ = NULL;
						SQLHeavyQuery* _tmp9_ = NULL;
						const gchar* _tmp10_ = NULL;
						SQLHeavyQuery* _tmp11_ = NULL;
						SQLHeavyQuery* _tmp12_ = NULL;
						const gchar* _tmp13_ = NULL;
						_tmp8_ = _result_;
						if (_tmp8_ != NULL) {
							g_critical ("sqlheavy-queryable.vala:104: Executing multiple statements from Querya" \
"ble.execute is deprecated. Use Queryable.run.");
						}
						_tmp10_ = s;
						_tmp11_ = sql_heavy_query_new_full (self, (const gchar*) _tmp10_, -1, &s, &_inner_error_);
						_tmp9_ = _tmp11_;
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							if (_inner_error_->domain == SQL_HEAVY_ERROR) {
								goto __catch21_sql_heavy_error;
							}
							_g_object_unref0 (query);
							_g_hash_table_unref0 (parameters);
							_g_object_unref0 (_result_);
							va_end (args);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
						_tmp12_ = _tmp9_;
						_tmp9_ = NULL;
						_g_object_unref0 (query);
						query = _tmp12_;
						_tmp13_ = s;
						sp = ((gchar*) _tmp13_) - 1;
						_g_object_unref0 (_tmp9_);
					}
					goto __finally21;
					__catch21_sql_heavy_error:
					{
						GError* e = NULL;
						GError* _tmp14_ = NULL;
						e = _inner_error_;
						_inner_error_ = NULL;
						_tmp14_ = e;
						if (g_error_matches (_tmp14_, SQL_HEAVY_ERROR, SQL_HEAVY_ERROR_NO_SQL)) {
							_g_error_free0 (e);
							_g_object_unref0 (query);
							break;
						} else {
							GError* _tmp15_ = NULL;
							GError* _tmp16_ = NULL;
							_tmp15_ = e;
							_tmp16_ = _g_error_copy0 (_tmp15_);
							_inner_error_ = _tmp16_;
							_g_error_free0 (e);
							goto __finally21;
						}
						_g_error_free0 (e);
					}
					__finally21:
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == SQL_HEAVY_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_object_unref0 (query);
							_g_hash_table_unref0 (parameters);
							_g_object_unref0 (_result_);
							va_end (args);
							return NULL;
						} else {
							_g_object_unref0 (query);
							_g_hash_table_unref0 (parameters);
							_g_object_unref0 (_result_);
							va_end (args);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
					_tmp17_ = query;
					_tmp18_ = sql_heavy_query_get_parameter_count (_tmp17_);
					_tmp19_ = _tmp18_;
					param_count = _tmp19_;
					{
						gint p = 0;
						p = 0;
						{
							gboolean _tmp20_ = FALSE;
							_tmp20_ = TRUE;
							while (TRUE) {
								gint _tmp22_ = 0;
								gint _tmp23_ = 0;
								GHashTable* _tmp24_ = NULL;
								const gchar* name = NULL;
								SQLHeavyQuery* _tmp28_ = NULL;
								gint _tmp29_ = 0;
								const gchar* _tmp30_ = NULL;
								GValue* value = NULL;
								GHashTable* _tmp31_ = NULL;
								const gchar* _tmp32_ = NULL;
								gconstpointer _tmp33_ = NULL;
								GValue* _tmp34_ = NULL;
								SQLHeavyQuery* _tmp37_ = NULL;
								const gchar* _tmp38_ = NULL;
								GValue* _tmp39_ = NULL;
								if (!_tmp20_) {
									gint _tmp21_ = 0;
									_tmp21_ = p;
									p = _tmp21_ + 1;
								}
								_tmp20_ = FALSE;
								_tmp22_ = p;
								_tmp23_ = param_count;
								if (!(_tmp22_ < _tmp23_)) {
									break;
								}
								_tmp24_ = parameters;
								if (_tmp24_ == NULL) {
									GHashTable* _tmp25_ = NULL;
									GHashTable* _tmp26_ = NULL;
									GHashTable* _tmp27_ = NULL;
									_tmp26_ = sql_heavy_queryable_va_list_to_hash_table (args, &_inner_error_);
									_tmp25_ = _tmp26_;
									if (G_UNLIKELY (_inner_error_ != NULL)) {
										if (_inner_error_->domain == SQL_HEAVY_ERROR) {
											g_propagate_error (error, _inner_error_);
											_g_object_unref0 (query);
											_g_hash_table_unref0 (parameters);
											_g_object_unref0 (_result_);
											va_end (args);
											return NULL;
										} else {
											_g_object_unref0 (query);
											_g_hash_table_unref0 (parameters);
											_g_object_unref0 (_result_);
											va_end (args);
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
											g_clear_error (&_inner_error_);
											return NULL;
										}
									}
									_tmp27_ = _tmp25_;
									_tmp25_ = NULL;
									_g_hash_table_unref0 (parameters);
									parameters = _tmp27_;
									_g_hash_table_unref0 (_tmp25_);
								}
								_tmp28_ = query;
								_tmp29_ = p;
								_tmp30_ = sql_heavy_query_parameter_name (_tmp28_, _tmp29_ + 1, &_inner_error_);
								name = _tmp30_;
								if (G_UNLIKELY (_inner_error_ != NULL)) {
									if (_inner_error_->domain == SQL_HEAVY_ERROR) {
										g_propagate_error (error, _inner_error_);
										_g_object_unref0 (query);
										_g_hash_table_unref0 (parameters);
										_g_object_unref0 (_result_);
										va_end (args);
										return NULL;
									} else {
										_g_object_unref0 (query);
										_g_hash_table_unref0 (parameters);
										_g_object_unref0 (_result_);
										va_end (args);
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
										g_clear_error (&_inner_error_);
										return NULL;
									}
								}
								_tmp31_ = parameters;
								_tmp32_ = name;
								_tmp33_ = g_hash_table_lookup (_tmp31_, _tmp32_);
								value = (GValue*) _tmp33_;
								_tmp34_ = value;
								if (_tmp34_ == NULL) {
									const gchar* _tmp35_ = NULL;
									GError* _tmp36_ = NULL;
									_tmp35_ = name;
									_tmp36_ = g_error_new (SQL_HEAVY_ERROR, SQL_HEAVY_ERROR_MISSING_PARAMETER, "Parameter `%s' left unbound", _tmp35_);
									_inner_error_ = _tmp36_;
									if (_inner_error_->domain == SQL_HEAVY_ERROR) {
										g_propagate_error (error, _inner_error_);
										_g_object_unref0 (query);
										_g_hash_table_unref0 (parameters);
										_g_object_unref0 (_result_);
										va_end (args);
										return NULL;
									} else {
										_g_object_unref0 (query);
										_g_hash_table_unref0 (parameters);
										_g_object_unref0 (_result_);
										va_end (args);
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
										g_clear_error (&_inner_error_);
										return NULL;
									}
								}
								_tmp37_ = query;
								_tmp38_ = name;
								_tmp39_ = value;
								sql_heavy_query_set (_tmp37_, _tmp38_, _tmp39_, &_inner_error_);
								if (G_UNLIKELY (_inner_error_ != NULL)) {
									if (_inner_error_->domain == SQL_HEAVY_ERROR) {
										g_propagate_error (error, _inner_error_);
										_g_object_unref0 (query);
										_g_hash_table_unref0 (parameters);
										_g_object_unref0 (_result_);
										va_end (args);
										return NULL;
									} else {
										_g_object_unref0 (query);
										_g_hash_table_unref0 (parameters);
										_g_object_unref0 (_result_);
										va_end (args);
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
										g_clear_error (&_inner_error_);
										return NULL;
									}
								}
							}
						}
					}
					_tmp41_ = query;
					_tmp42_ = sql_heavy_query_execute (_tmp41_, NULL, &_inner_error_, NULL);
					_tmp40_ = _tmp42_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == SQL_HEAVY_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_object_unref0 (query);
							_g_hash_table_unref0 (parameters);
							_g_object_unref0 (_result_);
							va_end (args);
							return NULL;
						} else {
							_g_object_unref0 (query);
							_g_hash_table_unref0 (parameters);
							_g_object_unref0 (_result_);
							va_end (args);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
					_tmp43_ = _tmp40_;
					_tmp40_ = NULL;
					_g_object_unref0 (_result_);
					_result_ = _tmp43_;
					_g_object_unref0 (_tmp40_);
					_g_object_unref0 (query);
				}
			}
		}
	}
	result = _result_;
	_g_hash_table_unref0 (parameters);
	va_end (args);
	return result;
}


/**
     * Execute the supplied SQL, iterating through multiple statements
     * if necessary.
     *
     * This function accepts an arbitrary number of groups of
     * arguments for binding values. The first argument in the group
     * must be the name of the parameter to bind, the second a GType,
     * and the third the value.
     *
     * @param sql the SQL query to run
     * @see Query.execute
     */
void sql_heavy_queryable_run (SQLHeavyQueryable* self, const gchar* sql, GError** error, ...) {
	const gchar* s = NULL;
	const gchar* _tmp0_ = NULL;
	va_list args = {0};
	GHashTable* parameters = NULL;
	SQLHeavyTransaction* trans = NULL;
	SQLHeavyTransaction* _tmp1_ = NULL;
	SQLHeavyTransaction* _tmp44_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (sql != NULL);
	_tmp0_ = sql;
	s = _tmp0_;
	va_start (args, error);
	parameters = NULL;
	_tmp1_ = sql_heavy_queryable_begin_transaction (self, &_inner_error_);
	trans = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == SQL_HEAVY_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_hash_table_unref0 (parameters);
			va_end (args);
			return;
		} else {
			_g_hash_table_unref0 (parameters);
			va_end (args);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	{
		gchar* sp = NULL;
		const gchar* _tmp2_ = NULL;
		_tmp2_ = s;
		sp = (gchar*) _tmp2_;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gchar* _tmp6_ = NULL;
				gchar* _tmp7_ = NULL;
				gboolean _tmp8_ = FALSE;
				if (!_tmp3_) {
					gchar* _tmp4_ = NULL;
					gchar* _tmp5_ = NULL;
					_tmp4_ = sp;
					sp = _tmp4_ + 1;
					_tmp5_ = sp;
					s = (const gchar*) _tmp5_;
				}
				_tmp3_ = FALSE;
				_tmp6_ = sp;
				if (!((*_tmp6_) != '\0')) {
					break;
				}
				_tmp7_ = sp;
				_tmp8_ = g_ascii_isspace (*_tmp7_);
				if (!_tmp8_) {
					SQLHeavyQuery* query = NULL;
					gint param_count = 0;
					SQLHeavyQuery* _tmp18_ = NULL;
					gint _tmp19_ = 0;
					gint _tmp20_ = 0;
					SQLHeavyQuery* _tmp41_ = NULL;
					SQLHeavyQueryResult* _tmp42_ = NULL;
					SQLHeavyQueryResult* _tmp43_ = NULL;
					query = NULL;
					{
						SQLHeavyQuery* _tmp9_ = NULL;
						SQLHeavyTransaction* _tmp10_ = NULL;
						const gchar* _tmp11_ = NULL;
						SQLHeavyQuery* _tmp12_ = NULL;
						SQLHeavyQuery* _tmp13_ = NULL;
						const gchar* _tmp14_ = NULL;
						_tmp10_ = trans;
						_tmp11_ = s;
						_tmp12_ = sql_heavy_query_new_full ((SQLHeavyQueryable*) _tmp10_, (const gchar*) _tmp11_, -1, &s, &_inner_error_);
						_tmp9_ = _tmp12_;
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							if (_inner_error_->domain == SQL_HEAVY_ERROR) {
								goto __catch22_sql_heavy_error;
							}
							_g_object_unref0 (query);
							_g_object_unref0 (trans);
							_g_hash_table_unref0 (parameters);
							va_end (args);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
						_tmp13_ = _tmp9_;
						_tmp9_ = NULL;
						_g_object_unref0 (query);
						query = _tmp13_;
						_tmp14_ = s;
						sp = ((gchar*) _tmp14_) - 1;
						_g_object_unref0 (_tmp9_);
					}
					goto __finally22;
					__catch22_sql_heavy_error:
					{
						GError* e = NULL;
						GError* _tmp15_ = NULL;
						e = _inner_error_;
						_inner_error_ = NULL;
						_tmp15_ = e;
						if (g_error_matches (_tmp15_, SQL_HEAVY_ERROR, SQL_HEAVY_ERROR_NO_SQL)) {
							_g_error_free0 (e);
							_g_object_unref0 (query);
							break;
						} else {
							GError* _tmp16_ = NULL;
							GError* _tmp17_ = NULL;
							_tmp16_ = e;
							_tmp17_ = _g_error_copy0 (_tmp16_);
							_inner_error_ = _tmp17_;
							_g_error_free0 (e);
							goto __finally22;
						}
						_g_error_free0 (e);
					}
					__finally22:
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == SQL_HEAVY_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_object_unref0 (query);
							_g_object_unref0 (trans);
							_g_hash_table_unref0 (parameters);
							va_end (args);
							return;
						} else {
							_g_object_unref0 (query);
							_g_object_unref0 (trans);
							_g_hash_table_unref0 (parameters);
							va_end (args);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
					_tmp18_ = query;
					_tmp19_ = sql_heavy_query_get_parameter_count (_tmp18_);
					_tmp20_ = _tmp19_;
					param_count = _tmp20_;
					{
						gint p = 0;
						p = 0;
						{
							gboolean _tmp21_ = FALSE;
							_tmp21_ = TRUE;
							while (TRUE) {
								gint _tmp23_ = 0;
								gint _tmp24_ = 0;
								GHashTable* _tmp25_ = NULL;
								const gchar* name = NULL;
								SQLHeavyQuery* _tmp29_ = NULL;
								gint _tmp30_ = 0;
								const gchar* _tmp31_ = NULL;
								GValue* value = NULL;
								GHashTable* _tmp32_ = NULL;
								const gchar* _tmp33_ = NULL;
								gconstpointer _tmp34_ = NULL;
								GValue* _tmp35_ = NULL;
								SQLHeavyQuery* _tmp38_ = NULL;
								const gchar* _tmp39_ = NULL;
								GValue* _tmp40_ = NULL;
								if (!_tmp21_) {
									gint _tmp22_ = 0;
									_tmp22_ = p;
									p = _tmp22_ + 1;
								}
								_tmp21_ = FALSE;
								_tmp23_ = p;
								_tmp24_ = param_count;
								if (!(_tmp23_ < _tmp24_)) {
									break;
								}
								_tmp25_ = parameters;
								if (_tmp25_ == NULL) {
									GHashTable* _tmp26_ = NULL;
									GHashTable* _tmp27_ = NULL;
									GHashTable* _tmp28_ = NULL;
									_tmp27_ = sql_heavy_queryable_va_list_to_hash_table (args, &_inner_error_);
									_tmp26_ = _tmp27_;
									if (G_UNLIKELY (_inner_error_ != NULL)) {
										if (_inner_error_->domain == SQL_HEAVY_ERROR) {
											g_propagate_error (error, _inner_error_);
											_g_object_unref0 (query);
											_g_object_unref0 (trans);
											_g_hash_table_unref0 (parameters);
											va_end (args);
											return;
										} else {
											_g_object_unref0 (query);
											_g_object_unref0 (trans);
											_g_hash_table_unref0 (parameters);
											va_end (args);
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
											g_clear_error (&_inner_error_);
											return;
										}
									}
									_tmp28_ = _tmp26_;
									_tmp26_ = NULL;
									_g_hash_table_unref0 (parameters);
									parameters = _tmp28_;
									_g_hash_table_unref0 (_tmp26_);
								}
								_tmp29_ = query;
								_tmp30_ = p;
								_tmp31_ = sql_heavy_query_parameter_name (_tmp29_, _tmp30_ + 1, &_inner_error_);
								name = _tmp31_;
								if (G_UNLIKELY (_inner_error_ != NULL)) {
									if (_inner_error_->domain == SQL_HEAVY_ERROR) {
										g_propagate_error (error, _inner_error_);
										_g_object_unref0 (query);
										_g_object_unref0 (trans);
										_g_hash_table_unref0 (parameters);
										va_end (args);
										return;
									} else {
										_g_object_unref0 (query);
										_g_object_unref0 (trans);
										_g_hash_table_unref0 (parameters);
										va_end (args);
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
										g_clear_error (&_inner_error_);
										return;
									}
								}
								_tmp32_ = parameters;
								_tmp33_ = name;
								_tmp34_ = g_hash_table_lookup (_tmp32_, _tmp33_);
								value = (GValue*) _tmp34_;
								_tmp35_ = value;
								if (_tmp35_ == NULL) {
									const gchar* _tmp36_ = NULL;
									GError* _tmp37_ = NULL;
									_tmp36_ = name;
									_tmp37_ = g_error_new (SQL_HEAVY_ERROR, SQL_HEAVY_ERROR_MISSING_PARAMETER, "Parameter `%s' left unbound", _tmp36_);
									_inner_error_ = _tmp37_;
									if (_inner_error_->domain == SQL_HEAVY_ERROR) {
										g_propagate_error (error, _inner_error_);
										_g_object_unref0 (query);
										_g_object_unref0 (trans);
										_g_hash_table_unref0 (parameters);
										va_end (args);
										return;
									} else {
										_g_object_unref0 (query);
										_g_object_unref0 (trans);
										_g_hash_table_unref0 (parameters);
										va_end (args);
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
										g_clear_error (&_inner_error_);
										return;
									}
								}
								_tmp38_ = query;
								_tmp39_ = name;
								_tmp40_ = value;
								sql_heavy_query_set (_tmp38_, _tmp39_, _tmp40_, &_inner_error_);
								if (G_UNLIKELY (_inner_error_ != NULL)) {
									if (_inner_error_->domain == SQL_HEAVY_ERROR) {
										g_propagate_error (error, _inner_error_);
										_g_object_unref0 (query);
										_g_object_unref0 (trans);
										_g_hash_table_unref0 (parameters);
										va_end (args);
										return;
									} else {
										_g_object_unref0 (query);
										_g_object_unref0 (trans);
										_g_hash_table_unref0 (parameters);
										va_end (args);
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
										g_clear_error (&_inner_error_);
										return;
									}
								}
							}
						}
					}
					_tmp41_ = query;
					_tmp42_ = sql_heavy_query_execute (_tmp41_, NULL, &_inner_error_, NULL);
					_tmp43_ = _tmp42_;
					_g_object_unref0 (_tmp43_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == SQL_HEAVY_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_object_unref0 (query);
							_g_object_unref0 (trans);
							_g_hash_table_unref0 (parameters);
							va_end (args);
							return;
						} else {
							_g_object_unref0 (query);
							_g_object_unref0 (trans);
							_g_hash_table_unref0 (parameters);
							va_end (args);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
					_g_object_unref0 (query);
				}
			}
		}
	}
	_tmp44_ = trans;
	sql_heavy_transaction_commit (_tmp44_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == SQL_HEAVY_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (trans);
			_g_hash_table_unref0 (parameters);
			va_end (args);
			return;
		} else {
			_g_object_unref0 (trans);
			_g_hash_table_unref0 (parameters);
			va_end (args);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_object_unref0 (trans);
	_g_hash_table_unref0 (parameters);
	va_end (args);
}


/**
     * Execute the supplied insert statement
     *
     * This function accepts an arbitrary number of groups of
     * arguments for binding values. The first argument in the group
     * must be the name of the parameter to bind, the second a GType,
     * and the third the value.
     *
     * @param sql an INSERT query
     * @return the inserted row ID
     * @see execute
     * @see Query.execute_insert
     */
gint64 sql_heavy_queryable_execute_insert (SQLHeavyQueryable* self, const gchar* sql, GError** error, ...) {
	gint64 result = 0LL;
	SQLHeavyQuery* query = NULL;
	const gchar* _tmp0_ = NULL;
	SQLHeavyQuery* _tmp1_ = NULL;
	va_list args = {0};
	SQLHeavyQuery* _tmp2_ = NULL;
	gint64 _tmp3_ = 0LL;
	SQLHeavyQuery* _tmp4_ = NULL;
	gint64 _tmp5_ = 0LL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (sql != NULL, 0LL);
	_tmp0_ = sql;
	_tmp1_ = sql_heavy_queryable_prepare (self, _tmp0_, &_inner_error_);
	query = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == SQL_HEAVY_ERROR) {
			g_propagate_error (error, _inner_error_);
			return 0LL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0LL;
		}
	}
	va_start (args, error);
	_tmp2_ = query;
	sql_heavy_query_set_list (_tmp2_, FALSE, NULL, args, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == SQL_HEAVY_ERROR) {
			g_propagate_error (error, _inner_error_);
			va_end (args);
			_g_object_unref0 (query);
			return 0LL;
		} else {
			va_end (args);
			_g_object_unref0 (query);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0LL;
		}
	}
	_tmp4_ = query;
	_tmp5_ = sql_heavy_query_execute_insert (_tmp4_, NULL, &_inner_error_, NULL);
	_tmp3_ = _tmp5_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == SQL_HEAVY_ERROR) {
			g_propagate_error (error, _inner_error_);
			va_end (args);
			_g_object_unref0 (query);
			return 0LL;
		} else {
			va_end (args);
			_g_object_unref0 (query);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0LL;
		}
	}
	result = _tmp3_;
	va_end (args);
	_g_object_unref0 (query);
	return result;
}


/**
     * Execute the supplied SQL, iterating through multiple statements if necessary.
     *
     * @param sql An SQL query.
     * @param max_len the maximum length of the query, or -1 to use strlen (sql)
     */
static void sql_heavy_queryable_run_internal (SQLHeavyQueryable* self, const gchar* sql, gssize max_len, GError** error) {
	const gchar* s = NULL;
	const gchar* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (sql != NULL);
	_tmp0_ = sql;
	s = _tmp0_;
	{
		gssize _tmp1_ = 0L;
		gssize _tmp2_ = 0L;
		gsize current_max = 0UL;
		_tmp2_ = max_len;
		if (_tmp2_ < ((gssize) 0)) {
			const gchar* _tmp3_ = NULL;
			gint _tmp4_ = 0;
			gint _tmp5_ = 0;
			_tmp3_ = s;
			_tmp4_ = strlen (_tmp3_);
			_tmp5_ = _tmp4_;
			_tmp1_ = (gssize) _tmp5_;
		} else {
			gssize _tmp6_ = 0L;
			_tmp6_ = max_len;
			_tmp1_ = _tmp6_;
		}
		current_max = (gsize) _tmp1_;
		{
			gboolean _tmp7_ = FALSE;
			_tmp7_ = TRUE;
			while (TRUE) {
				gboolean _tmp8_ = FALSE;
				const gchar* _tmp9_ = NULL;
				gchar* os = NULL;
				const gchar* _tmp11_ = NULL;
				gsize _tmp20_ = 0UL;
				const gchar* _tmp21_ = NULL;
				gchar* _tmp22_ = NULL;
				if (!_tmp7_) {
				}
				_tmp7_ = FALSE;
				_tmp9_ = s;
				if (_tmp9_ != NULL) {
					gsize _tmp10_ = 0UL;
					_tmp10_ = current_max;
					_tmp8_ = _tmp10_ > ((gsize) 0);
				} else {
					_tmp8_ = FALSE;
				}
				if (!_tmp8_) {
					break;
				}
				_tmp11_ = s;
				os = (gchar*) _tmp11_;
				{
					SQLHeavyQuery* _tmp12_ = NULL;
					const gchar* _tmp13_ = NULL;
					gsize _tmp14_ = 0UL;
					SQLHeavyQuery* _tmp15_ = NULL;
					SQLHeavyQuery* _tmp16_ = NULL;
					SQLHeavyQuery* _tmp17_ = NULL;
					SQLHeavyQueryResult* _tmp18_ = NULL;
					SQLHeavyQueryResult* _tmp19_ = NULL;
					_tmp13_ = s;
					_tmp14_ = current_max;
					_tmp15_ = sql_heavy_query_new_full (self, (const gchar*) _tmp13_, (gint) _tmp14_, &s, &_inner_error_);
					_tmp12_ = _tmp15_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == SQL_HEAVY_ERROR) {
							g_propagate_error (error, _inner_error_);
							return;
						} else {
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
					_tmp16_ = _tmp12_;
					_tmp12_ = NULL;
					_tmp17_ = _tmp16_;
					_tmp18_ = sql_heavy_query_execute (_tmp17_, NULL, &_inner_error_, NULL);
					_tmp19_ = _tmp18_;
					_g_object_unref0 (_tmp19_);
					_g_object_unref0 (_tmp17_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == SQL_HEAVY_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_object_unref0 (_tmp12_);
							return;
						} else {
							_g_object_unref0 (_tmp12_);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
					_g_object_unref0 (_tmp12_);
				}
				_tmp20_ = current_max;
				_tmp21_ = s;
				_tmp22_ = os;
				current_max = _tmp20_ - (((gchar*) _tmp21_) - _tmp22_);
				{
					gchar* sp = NULL;
					const gchar* _tmp23_ = NULL;
					_tmp23_ = s;
					sp = (gchar*) _tmp23_;
					{
						gboolean _tmp24_ = FALSE;
						_tmp24_ = TRUE;
						while (TRUE) {
							gsize _tmp28_ = 0UL;
							gchar* _tmp29_ = NULL;
							gboolean _tmp30_ = FALSE;
							if (!_tmp24_) {
								gsize _tmp25_ = 0UL;
								gchar* _tmp26_ = NULL;
								gchar* _tmp27_ = NULL;
								_tmp25_ = current_max;
								current_max = _tmp25_ - 1;
								_tmp26_ = sp;
								sp = _tmp26_ + 1;
								_tmp27_ = sp;
								s = (const gchar*) _tmp27_;
							}
							_tmp24_ = FALSE;
							_tmp28_ = current_max;
							if (!(_tmp28_ > ((gsize) 0))) {
								break;
							}
							_tmp29_ = sp;
							_tmp30_ = g_ascii_isspace (*_tmp29_);
							if (!_tmp30_) {
								break;
							}
						}
					}
				}
			}
		}
	}
}


/**
     * Create a prepared statement.
     *
     * @param sql An SQL query.
     * @return a new statement
     */
static SQLHeavyQuery* sql_heavy_queryable_real_prepare (SQLHeavyQueryable* self, const gchar* sql, GError** error) {
	SQLHeavyQuery* result = NULL;
	SQLHeavyQuery* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	SQLHeavyQuery* _tmp2_ = NULL;
	SQLHeavyQuery* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (sql != NULL, NULL);
	_tmp1_ = sql;
	_tmp2_ = sql_heavy_query_new (self, _tmp1_, &_inner_error_);
	_tmp0_ = _tmp2_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == SQL_HEAVY_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp3_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp3_;
	_g_object_unref0 (_tmp0_);
	return result;
}


SQLHeavyQuery* sql_heavy_queryable_prepare (SQLHeavyQueryable* self, const gchar* sql, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return SQL_HEAVY_QUERYABLE_GET_INTERFACE (self)->prepare (self, sql, error);
}


/**
     * Runs an SQL script located in a file
     *
     * @param filename the location of the script
     */
static guint8* g_string_get_data (GString* self, int* result_length1) {
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_ = NULL;
	gint res_length1 = 0;
	gint _res_size_ = 0;
	gssize _tmp1_ = 0L;
	gint _tmp2_ = 0;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	guint8* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->str;
	res = (guint8*) _tmp0_;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp1_ = self->len;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res_length1;
	_tmp3_ = res;
	_tmp3__length1 = res_length1;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}


static void sql_heavy_queryable_real_run_file (SQLHeavyQueryable* self, GFile* file, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (file != NULL);
	{
		GString* script = NULL;
		GString* _tmp0_ = NULL;
		SQLHeavyTransaction* trans = NULL;
		SQLHeavyTransaction* _tmp12_ = NULL;
		SQLHeavyTransaction* _tmp13_ = NULL;
		GString* _tmp14_ = NULL;
		guint8* _tmp15_ = NULL;
		gint _tmp15__length1 = 0;
		guint8* _tmp16_ = NULL;
		gint _tmp16__length1 = 0;
		GString* _tmp17_ = NULL;
		gssize _tmp18_ = 0L;
		SQLHeavyTransaction* _tmp19_ = NULL;
		_tmp0_ = g_string_sized_new ((gsize) 4096);
		script = _tmp0_;
		{
			GInputStream* input = NULL;
			GFile* _tmp1_ = NULL;
			GFileInputStream* _tmp2_ = NULL;
			guint8* data = NULL;
			guint8* _tmp3_ = NULL;
			gint data_length1 = 0;
			gint _data_size_ = 0;
			gssize bytes_read = 0L;
			_tmp1_ = file;
			_tmp2_ = g_file_read (_tmp1_, NULL, &_inner_error_);
			input = (GInputStream*) _tmp2_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_string_free0 (script);
				goto __catch23_g_error;
			}
			_tmp3_ = g_new0 (guint8, 4096);
			data = _tmp3_;
			data_length1 = 4096;
			_data_size_ = data_length1;
			bytes_read = (gssize) 0;
			while (TRUE) {
				gssize _tmp4_ = 0L;
				GInputStream* _tmp5_ = NULL;
				guint8* _tmp6_ = NULL;
				gint _tmp6__length1 = 0;
				gssize _tmp7_ = 0L;
				gssize _tmp8_ = 0L;
				GString* _tmp9_ = NULL;
				guint8* _tmp10_ = NULL;
				gint _tmp10__length1 = 0;
				gssize _tmp11_ = 0L;
				_tmp5_ = input;
				_tmp6_ = data;
				_tmp6__length1 = data_length1;
				_tmp7_ = g_input_stream_read (_tmp5_, _tmp6_, (gsize) _tmp6__length1, NULL, &_inner_error_);
				_tmp4_ = _tmp7_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					data = (g_free (data), NULL);
					_g_object_unref0 (input);
					_g_string_free0 (script);
					goto __catch23_g_error;
				}
				bytes_read = _tmp4_;
				_tmp8_ = bytes_read;
				if (!(_tmp8_ > ((gssize) 0))) {
					break;
				}
				_tmp9_ = script;
				_tmp10_ = data;
				_tmp10__length1 = data_length1;
				_tmp11_ = bytes_read;
				g_string_append_len (_tmp9_, (const gchar*) _tmp10_, _tmp11_);
			}
			data = (g_free (data), NULL);
			_g_object_unref0 (input);
		}
		_tmp12_ = sql_heavy_queryable_begin_transaction (self, &_inner_error_);
		trans = _tmp12_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_string_free0 (script);
			goto __catch23_g_error;
		}
		_tmp13_ = trans;
		_tmp14_ = script;
		_tmp15_ = g_string_get_data (_tmp14_, &_tmp15__length1);
		_tmp16_ = _tmp15_;
		_tmp16__length1 = _tmp15__length1;
		_tmp17_ = script;
		_tmp18_ = _tmp17_->len;
		sql_heavy_queryable_run_internal ((SQLHeavyQueryable*) _tmp13_, (const gchar*) _tmp16_, _tmp18_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (trans);
			_g_string_free0 (script);
			goto __catch23_g_error;
		}
		_tmp19_ = trans;
		sql_heavy_transaction_commit (_tmp19_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (trans);
			_g_string_free0 (script);
			goto __catch23_g_error;
		}
		_g_object_unref0 (trans);
		_g_string_free0 (script);
	}
	goto __finally23;
	__catch23_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		GError* _tmp22_ = NULL;
		gint _tmp23_ = 0;
		GError* _tmp24_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp20_ = e;
		_tmp21_ = _tmp20_->message;
		_tmp22_ = e;
		_tmp23_ = _tmp22_->code;
		_tmp24_ = g_error_new (SQL_HEAVY_ERROR, SQL_HEAVY_ERROR_IO, "Unable to open script: %s (%d).", _tmp21_, _tmp23_);
		_inner_error_ = _tmp24_;
		_g_error_free0 (e);
		goto __finally23;
	}
	__finally23:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == SQL_HEAVY_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void sql_heavy_queryable_run_file (SQLHeavyQueryable* self, GFile* file, GError** error) {
	g_return_if_fail (self != NULL);
	SQL_HEAVY_QUERYABLE_GET_INTERFACE (self)->run_file (self, file, error);
}


/**
     * Runs an SQL script located in a file
     *
     * @param filename the location of the script
     */
void sql_heavy_queryable_run_script (SQLHeavyQueryable* self, const gchar* filename, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (filename != NULL);
	{
		GMappedFile* file = NULL;
		const gchar* _tmp0_ = NULL;
		GMappedFile* _tmp1_ = NULL;
		SQLHeavyTransaction* trans = NULL;
		SQLHeavyTransaction* _tmp2_ = NULL;
		SQLHeavyTransaction* _tmp3_ = NULL;
		GMappedFile* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GMappedFile* _tmp6_ = NULL;
		gsize _tmp7_ = 0UL;
		SQLHeavyTransaction* _tmp8_ = NULL;
		_tmp0_ = filename;
		_tmp1_ = g_mapped_file_new (_tmp0_, FALSE, &_inner_error_);
		file = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch24_g_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp2_ = sql_heavy_queryable_begin_transaction (self, &_inner_error_);
		trans = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_mapped_file_unref0 (file);
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch24_g_file_error;
			}
			goto __finally24;
		}
		_tmp3_ = trans;
		_tmp4_ = file;
		_tmp5_ = g_mapped_file_get_contents (_tmp4_);
		_tmp6_ = file;
		_tmp7_ = g_mapped_file_get_length (_tmp6_);
		sql_heavy_queryable_run_internal ((SQLHeavyQueryable*) _tmp3_, (const gchar*) _tmp5_, (gssize) _tmp7_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (trans);
			_g_mapped_file_unref0 (file);
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch24_g_file_error;
			}
			goto __finally24;
		}
		_tmp8_ = trans;
		sql_heavy_transaction_commit (_tmp8_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (trans);
			_g_mapped_file_unref0 (file);
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch24_g_file_error;
			}
			goto __finally24;
		}
		_g_object_unref0 (trans);
		_g_mapped_file_unref0 (file);
	}
	goto __finally24;
	__catch24_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
		gint _tmp12_ = 0;
		GError* _tmp13_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->code;
		_tmp13_ = g_error_new (SQL_HEAVY_ERROR, SQL_HEAVY_ERROR_IO, "Unable to open script: %s (%d).", _tmp10_, _tmp12_);
		_inner_error_ = _tmp13_;
		_g_error_free0 (e);
		goto __finally24;
	}
	__finally24:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == SQL_HEAVY_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
     * Print the result set to a file stream
     *
     * @param sql the query
     * @param fd the stream to print to
     * @see Queryable.print_table
     */
static void sql_heavy_queryable_real_print_table (SQLHeavyQueryable* self, const gchar* sql, FILE* fd, GError** error) {
	SQLHeavyQuery* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	SQLHeavyQuery* _tmp2_ = NULL;
	SQLHeavyQuery* _tmp3_ = NULL;
	SQLHeavyQuery* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (sql != NULL);
	_tmp1_ = sql;
	_tmp2_ = sql_heavy_queryable_prepare (self, _tmp1_, &_inner_error_);
	_tmp0_ = _tmp2_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == SQL_HEAVY_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp3_ = _tmp0_;
	_tmp0_ = NULL;
	_tmp4_ = _tmp3_;
	sql_heavy_query_print_table (_tmp4_, NULL, &_inner_error_);
	_g_object_unref0 (_tmp4_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == SQL_HEAVY_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (_tmp0_);
			return;
		} else {
			_g_object_unref0 (_tmp0_);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_object_unref0 (_tmp0_);
}


void sql_heavy_queryable_print_table (SQLHeavyQueryable* self, const gchar* sql, FILE* fd, GError** error) {
	g_return_if_fail (self != NULL);
	SQL_HEAVY_QUERYABLE_GET_INTERFACE (self)->print_table (self, sql, fd, error);
}


SQLHeavyDatabase* sql_heavy_queryable_get_database (SQLHeavyQueryable* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return SQL_HEAVY_QUERYABLE_GET_INTERFACE (self)->get_database (self);
}


static void sql_heavy_queryable_base_init (SQLHeavyQueryableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		/**
		     * Database
		     */
		g_object_interface_install_property (iface, g_param_spec_object ("database", "database", "database", SQL_HEAVY_TYPE_DATABASE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
		/**
		     * Signal which is emitted when a query finished executing.
		     *
		     * @param query the query which was executed
		     * @see Database.sql_executed
		     */
		g_signal_new ("query_executed", SQL_HEAVY_TYPE_QUERYABLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, SQL_HEAVY_TYPE_QUERY);
		iface->begin_transaction = sql_heavy_queryable_real_begin_transaction;
		iface->prepare = sql_heavy_queryable_real_prepare;
		iface->run_file = sql_heavy_queryable_real_run_file;
		iface->print_table = sql_heavy_queryable_real_print_table;
	}
}


/**
   * Interface on which queries may be run
   */
GType sql_heavy_queryable_get_type (void) {
	static volatile gsize sql_heavy_queryable_type_id__volatile = 0;
	if (g_once_init_enter (&sql_heavy_queryable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SQLHeavyQueryableIface), (GBaseInitFunc) sql_heavy_queryable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType sql_heavy_queryable_type_id;
		sql_heavy_queryable_type_id = g_type_register_static (G_TYPE_INTERFACE, "SQLHeavyQueryable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (sql_heavy_queryable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&sql_heavy_queryable_type_id__volatile, sql_heavy_queryable_type_id);
	}
	return sql_heavy_queryable_type_id__volatile;
}



