/* sqlheavy-versioned-database.c generated by valac 0.28.1, the Vala compiler
 * generated from sqlheavy-versioned-database.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include "SQLHeavy.h"
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SQLHeavyVersionedDatabasePrivate {
	gchar* _schema;
};


static gpointer sql_heavy_versioned_database_parent_class = NULL;

#define SQL_HEAVY_VERSIONED_DATABASE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SQL_HEAVY_TYPE_VERSIONED_DATABASE, SQLHeavyVersionedDatabasePrivate))
enum  {
	SQL_HEAVY_VERSIONED_DATABASE_DUMMY_PROPERTY,
	SQL_HEAVY_VERSIONED_DATABASE_SCHEMA
};
static void sql_heavy_versioned_database_real_pre_upgrade (SQLHeavyVersionedDatabase* self, gint new_version);
static GObject * sql_heavy_versioned_database_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void sql_heavy_versioned_database_finalize (GObject* obj);
static void _vala_sql_heavy_versioned_database_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_sql_heavy_versioned_database_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
     * Invoked after the database has been upgraded to a new version.
     *
     * This method allows subclasses to hook in and discover when a
     * database is updated, prompt the user to ask permission to
     * update, back-up the database first, etc.
     *
     * Note that this function may be invoked multiple times (if the
     * database needs to be upgraded by multiple versions.
     *
     * @param new_version the version number to update to
     */
static void sql_heavy_versioned_database_real_pre_upgrade (SQLHeavyVersionedDatabase* self, gint new_version) {
}


void sql_heavy_versioned_database_pre_upgrade (SQLHeavyVersionedDatabase* self, gint new_version) {
	g_return_if_fail (self != NULL);
	SQL_HEAVY_VERSIONED_DATABASE_GET_CLASS (self)->pre_upgrade (self, new_version);
}


/**
     * Create a VersionedDatabase
     *
     * @param file The filename of the database
     * @param directory the directory where the schema can be found
     */
SQLHeavyVersionedDatabase* sql_heavy_versioned_database_construct (GType object_type, const gchar* file, const gchar* directory, GError** error) {
	SQLHeavyVersionedDatabase * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_val_if_fail (directory != NULL, NULL);
	_tmp1_ = file;
	_tmp0_ = _tmp1_;
	if (_tmp0_ == NULL) {
		_tmp0_ = ":memory:";
	}
	_tmp2_ = directory;
	self = (SQLHeavyVersionedDatabase*) g_object_new (object_type, "filename", _tmp0_, "schema", _tmp2_, NULL);
	return self;
}


SQLHeavyVersionedDatabase* sql_heavy_versioned_database_new (const gchar* file, const gchar* directory, GError** error) {
	return sql_heavy_versioned_database_construct (SQL_HEAVY_TYPE_VERSIONED_DATABASE, file, directory, error);
}


const gchar* sql_heavy_versioned_database_get_schema (SQLHeavyVersionedDatabase* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_schema;
	result = _tmp0_;
	return result;
}


static void sql_heavy_versioned_database_set_schema (SQLHeavyVersionedDatabase* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_schema);
	self->priv->_schema = _tmp1_;
	g_object_notify ((GObject *) self, "schema");
}


static GObject * sql_heavy_versioned_database_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SQLHeavyVersionedDatabase * self;
	gint version = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gchar* script_name = NULL;
	gint _tmp4_ = 0;
	GError * _inner_error_ = NULL;
	parent_class = G_OBJECT_CLASS (sql_heavy_versioned_database_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SQL_HEAVY_TYPE_VERSIONED_DATABASE, SQLHeavyVersionedDatabase);
	{
		sql_heavy_database_init ((SQLHeavyDatabase*) self, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == SQL_HEAVY_ERROR) {
				goto __catch50_sql_heavy_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
	}
	goto __finally50;
	__catch50_sql_heavy_error:
	{
		GError* err = NULL;
		GError* _tmp0_ = NULL;
		const gchar* _tmp1_ = NULL;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp0_ = err;
		_tmp1_ = _tmp0_->message;
		g_critical ("sqlheavy-versioned-database.vala:41: Unable to initialize versioned da" \
"tabase: %s", _tmp1_);
		_g_error_free0 (err);
	}
	__finally50:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_tmp2_ = sql_heavy_database_get_user_version ((SQLHeavyDatabase*) self);
	_tmp3_ = _tmp2_;
	version = _tmp3_;
	_tmp4_ = version;
	if (_tmp4_ == 0) {
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		gint _tmp17_ = 0;
		{
			const gchar* _tmp5_ = NULL;
			gchar* _tmp6_ = NULL;
			const gchar* _tmp7_ = NULL;
			GFile* _tmp8_ = NULL;
			GFile* _tmp9_ = NULL;
			sql_heavy_versioned_database_pre_upgrade (self, 1);
			_tmp5_ = self->priv->_schema;
			_tmp6_ = g_strconcat (_tmp5_, "/Create.sql", NULL);
			_g_free0 (script_name);
			script_name = _tmp6_;
			_tmp7_ = script_name;
			_tmp8_ = g_file_new_for_uri (_tmp7_);
			_tmp9_ = _tmp8_;
			sql_heavy_queryable_run_file ((SQLHeavyQueryable*) self, _tmp9_, &_inner_error_);
			_g_object_unref0 (_tmp9_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == SQL_HEAVY_ERROR) {
					goto __catch51_sql_heavy_error;
				}
				_g_free0 (script_name);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
			}
		}
		goto __finally51;
		__catch51_sql_heavy_error:
		{
			GError* e = NULL;
			const gchar* _tmp10_ = NULL;
			GError* _tmp11_ = NULL;
			const gchar* _tmp12_ = NULL;
			GError* _tmp13_ = NULL;
			gint _tmp14_ = 0;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp10_ = script_name;
			_tmp11_ = e;
			_tmp12_ = _tmp11_->message;
			_tmp13_ = e;
			_tmp14_ = _tmp13_->code;
			g_critical ("sqlheavy-versioned-database.vala:54: Unable to run creation script `%s" \
"' (%s: %d).", _tmp10_, _tmp12_, _tmp14_);
			_g_error_free0 (e);
		}
		__finally51:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (script_name);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
		_tmp15_ = sql_heavy_database_get_user_version ((SQLHeavyDatabase*) self);
		_tmp16_ = _tmp15_;
		version = _tmp16_;
		_tmp17_ = version;
		if (_tmp17_ == 0) {
			gint _tmp18_ = 0;
			version = 1;
			_tmp18_ = version;
			sql_heavy_database_set_user_version ((SQLHeavyDatabase*) self, _tmp18_);
		}
	}
	{
		SQLHeavyTransaction* trans = NULL;
		SQLHeavyTransaction* _tmp35_ = NULL;
		trans = NULL;
		while (TRUE) {
			const gchar* _tmp19_ = NULL;
			gint _tmp20_ = 0;
			gchar* _tmp21_ = NULL;
			GFile* script = NULL;
			const gchar* _tmp22_ = NULL;
			GFile* _tmp23_ = NULL;
			GFile* _tmp24_ = NULL;
			gboolean _tmp25_ = FALSE;
			gint _tmp26_ = 0;
			gint _tmp27_ = 0;
			SQLHeavyTransaction* _tmp28_ = NULL;
			SQLHeavyTransaction* _tmp32_ = NULL;
			GFile* _tmp33_ = NULL;
			gint _tmp34_ = 0;
			_tmp19_ = self->priv->_schema;
			_tmp20_ = version;
			_tmp21_ = g_strdup_printf ("%s/Update-to-%d.sql", _tmp19_, _tmp20_ + 1);
			_g_free0 (script_name);
			script_name = _tmp21_;
			_tmp22_ = script_name;
			_tmp23_ = g_file_new_for_uri (_tmp22_);
			script = _tmp23_;
			_tmp24_ = script;
			_tmp25_ = g_file_query_exists (_tmp24_, NULL);
			if (!_tmp25_) {
				_g_object_unref0 (script);
				break;
			}
			_tmp26_ = version;
			version = _tmp26_ + 1;
			_tmp27_ = version;
			sql_heavy_versioned_database_pre_upgrade (self, _tmp27_);
			_tmp28_ = trans;
			if (_tmp28_ == NULL) {
				SQLHeavyTransaction* _tmp29_ = NULL;
				SQLHeavyTransaction* _tmp30_ = NULL;
				SQLHeavyTransaction* _tmp31_ = NULL;
				_tmp30_ = sql_heavy_queryable_begin_transaction ((SQLHeavyQueryable*) self, &_inner_error_);
				_tmp29_ = _tmp30_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_object_unref0 (script);
					_g_object_unref0 (trans);
					if (_inner_error_->domain == SQL_HEAVY_ERROR) {
						goto __catch52_sql_heavy_error;
					}
					_g_object_unref0 (script);
					_g_object_unref0 (trans);
					_g_free0 (script_name);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
				}
				_tmp31_ = _tmp29_;
				_tmp29_ = NULL;
				_g_object_unref0 (trans);
				trans = _tmp31_;
				_g_object_unref0 (_tmp29_);
			}
			_tmp32_ = trans;
			_tmp33_ = script;
			sql_heavy_queryable_run_file ((SQLHeavyQueryable*) _tmp32_, _tmp33_, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (script);
				_g_object_unref0 (trans);
				if (_inner_error_->domain == SQL_HEAVY_ERROR) {
					goto __catch52_sql_heavy_error;
				}
				_g_object_unref0 (script);
				_g_object_unref0 (trans);
				_g_free0 (script_name);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
			}
			_tmp34_ = version;
			sql_heavy_database_set_user_version ((SQLHeavyDatabase*) self, _tmp34_);
			_g_object_unref0 (script);
		}
		_tmp35_ = trans;
		if (_tmp35_ != NULL) {
			SQLHeavyTransaction* _tmp36_ = NULL;
			_tmp36_ = trans;
			sql_heavy_transaction_commit (_tmp36_, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (trans);
				if (_inner_error_->domain == SQL_HEAVY_ERROR) {
					goto __catch52_sql_heavy_error;
				}
				_g_object_unref0 (trans);
				_g_free0 (script_name);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
			}
		}
		_g_object_unref0 (trans);
	}
	goto __finally52;
	__catch52_sql_heavy_error:
	{
		GError* e = NULL;
		const gchar* _tmp37_ = NULL;
		GError* _tmp38_ = NULL;
		const gchar* _tmp39_ = NULL;
		GError* _tmp40_ = NULL;
		gint _tmp41_ = 0;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp37_ = script_name;
		_tmp38_ = e;
		_tmp39_ = _tmp38_->message;
		_tmp40_ = e;
		_tmp41_ = _tmp40_->code;
		g_critical ("sqlheavy-versioned-database.vala:85: Unable to run update script `%s' " \
"(%s: %d).", _tmp37_, _tmp39_, _tmp41_);
		_g_error_free0 (e);
	}
	__finally52:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (script_name);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_g_free0 (script_name);
	return obj;
}


static void sql_heavy_versioned_database_class_init (SQLHeavyVersionedDatabaseClass * klass) {
	sql_heavy_versioned_database_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SQLHeavyVersionedDatabasePrivate));
	((SQLHeavyVersionedDatabaseClass *) klass)->pre_upgrade = sql_heavy_versioned_database_real_pre_upgrade;
	G_OBJECT_CLASS (klass)->get_property = _vala_sql_heavy_versioned_database_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sql_heavy_versioned_database_set_property;
	G_OBJECT_CLASS (klass)->constructor = sql_heavy_versioned_database_constructor;
	G_OBJECT_CLASS (klass)->finalize = sql_heavy_versioned_database_finalize;
	/**
	     * Location of database schema directory
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SQL_HEAVY_VERSIONED_DATABASE_SCHEMA, g_param_spec_string ("schema", "schema", "schema", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void sql_heavy_versioned_database_instance_init (SQLHeavyVersionedDatabase * self) {
	self->priv = SQL_HEAVY_VERSIONED_DATABASE_GET_PRIVATE (self);
}


static void sql_heavy_versioned_database_finalize (GObject* obj) {
	SQLHeavyVersionedDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SQL_HEAVY_TYPE_VERSIONED_DATABASE, SQLHeavyVersionedDatabase);
	_g_free0 (self->priv->_schema);
	G_OBJECT_CLASS (sql_heavy_versioned_database_parent_class)->finalize (obj);
}


/**
   * A class used to represent a database and its schema
   *
   * The {@link schema} should be a directory which
   * contains a Create.sql script to create the database and set the
   * [[http://www.sqlite.org/pragma.html#version|user_version]].
   *
   * Each time the database is opened, it will check for scripts
   * named Update-to-%d.sql to update the schema to the version
   * number represented by %d (i.e., user_version + 1), and execute
   * them when appropriate.
   *
   * This provides an easy way to keep your database schema up to data
   * when you update your program.
   */
GType sql_heavy_versioned_database_get_type (void) {
	static volatile gsize sql_heavy_versioned_database_type_id__volatile = 0;
	if (g_once_init_enter (&sql_heavy_versioned_database_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SQLHeavyVersionedDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sql_heavy_versioned_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SQLHeavyVersionedDatabase), 0, (GInstanceInitFunc) sql_heavy_versioned_database_instance_init, NULL };
		GType sql_heavy_versioned_database_type_id;
		sql_heavy_versioned_database_type_id = g_type_register_static (SQL_HEAVY_TYPE_DATABASE, "SQLHeavyVersionedDatabase", &g_define_type_info, 0);
		g_once_init_leave (&sql_heavy_versioned_database_type_id__volatile, sql_heavy_versioned_database_type_id);
	}
	return sql_heavy_versioned_database_type_id__volatile;
}


static void _vala_sql_heavy_versioned_database_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SQLHeavyVersionedDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SQL_HEAVY_TYPE_VERSIONED_DATABASE, SQLHeavyVersionedDatabase);
	switch (property_id) {
		case SQL_HEAVY_VERSIONED_DATABASE_SCHEMA:
		g_value_set_string (value, sql_heavy_versioned_database_get_schema (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_sql_heavy_versioned_database_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SQLHeavyVersionedDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SQL_HEAVY_TYPE_VERSIONED_DATABASE, SQLHeavyVersionedDatabase);
	switch (property_id) {
		case SQL_HEAVY_VERSIONED_DATABASE_SCHEMA:
		sql_heavy_versioned_database_set_schema (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



